   --  襭    譥 
   -- *********************************************************
   import Tree
   ---------------------------------------------------------
   -- 㭪, 㤠  ୮ ॢ ᪠  -
   -- 設, ᯮ  ஢,   k
   ------------------------------------------------------
   tCopy' k Nil = Nil
   tCopy' k tree | topNode (root tree) tree==k 
                             = list (root tree)
                 | True      = node (root tree) 
                                    (tCopy' (k-1) (left tree))
                                    (tCopy' (k-1) (right tree))
   ---------------------------------------------------------------
   -- 㭪,  ᯨ᮪ 設 ୮ ॢ ᪠,
   -- 室   ஢ k ( 맮 tree1:=tree)
   ------------------------------------------------------------
   levelTree:: Int -> BTree -> BTree -> [Int]
   levelTree k tree tree1 
                 | tree==Nil = []
                 | True      =   levelTree k (left tree) tree1
                              ++ (f (root tree) tree1)
                              ++ levelTree k (right tree) tree1
        where f x tree | topNode x tree==k = [x]
                       | True              = []
   --------------------------------------------------------------
   -- ।, ⠭騩,  ୮ ॢ ᪠ tree1
   --  ॢ ୮ ॢ ᪠ tree2
   ----------------------------------------------------
   subTree:: BTree -> BTree -> Bool
   subTree tree1 tree2 | isEmpty tree1 || 
                         isEmpty tree1 && isEmpty tree2
                                       = True
                       | isEmpty tree2 = False
                       | True          =   root tree1==root tree2
                                        && subTree (left tree1)
                                                   (left tree2)
                                        && subTree (right tree1)
                                                   (right tree2)
   -------------------------------------------------------------
   -- ।, ᯮ騩 ୮ ॢ ᪠ tree
   -----------------------------------------------------
   isBTree:: BTree -> Bool
   isBTree tree | isEmpty tree = True
                | isEmpty (left tree) && isEmpty (right tree)
                               = True
                | isEmpty (left tree)
                               =   root tree<root (right tree)
                                && isBTree (right tree)
                | isEmpty (right tree)
                               =   root tree>root (left tree)
                              && isBTree (left tree)
                | True         =   root tree>root (left tree)
                                && root tree<root (right tree)
                                && isBTree (left tree)
                                && isBTree (right tree)
   -- *************************************************
   -- 㤠 ⮢ ਬ:
   --------------------------------
   tree = node 10 (node  6 (list 3)
                           (node  7 nil (list 8)))
                  (node 15 (list 12) 
                           (node 18 (list 17) nil))
   tree1 = node 5 (node 3 (list 1) (list 4))          
                  (node 7 (list 6)           
                          (node 9 (list 8) (list 15)))
   tree2 = newRndTree 4 44 9
   ----------------------------------------------
   test1 = putStr(   show (tCopy' 0 tree) ++ "\n"
                  ++ show (tCopy' 1 tree) ++ "\n"
                  ++ show (tCopy' 2 tree) ++ "\n"
                  ++ show (tCopy' 3 tree) 
                  ++ show (tCopy' 4 tree) ++ "\n")
   -----------------------------------------------
   test2 =   levelTree 0 tree tree == [10]
          && levelTree 1 tree tree == [6,15]
          && levelTree 2 tree tree == [3,7,12,18]
          && levelTree 3 tree tree == [8,17]
          && levelTree 4 tree tree == []
   -----------------------------------------
   test3 =    levelTree 0 tree1 tree1 == [5]
           && levelTree 1 tree1 tree1 == [3,7]
           && levelTree 2 tree1 tree1 == [1,4,6,9]
           && levelTree 3 tree1 tree1 == [8,15]
           && levelTree 4 tree1 tree1 == []
   ----------------------------------------
   test31 = levelTree 0 tree1 tree1 ++
            levelTree 1 tree1 tree1 ++
            levelTree 2 tree1 tree1 ++
            levelTree 3 tree1 tree1 ++
            levelTree 4 tree1 tree1
   --------------------------------------
   test4 =   subTree (tCopy' 0 tree) tree
          && subTree (tCopy' 1 tree) tree
          && subTree (tCopy' 2 tree) tree
          && subTree (tCopy' 3 tree) tree
          ---------------------------------
          && subTree (tCopy' 2 tree2) tree2
          && subTree (tCopy' 3 tree2) tree2
   ------------------------------------------------------
   test5 = isBTree tree && isBTree tree1 && isBTree tree2
   ------------------------------------------------------
   tree3 = node 10 (node  6 (list 3)
                            (node 17 nil (list 8)))
                   (node 15 (list 12) 
                            (node 18 (list 17) nil))
   tree4 = node 10 (node 6 (list 3)
                           (node  7 nil (list 8)))
                   (node 1 (list 12) 
                           (node 18 (list 17) nil))
   test6 = outTree tree4
   test7 = not (isBTree tree3) && not (isBTree tree4)
   test8 = isBTree tree1 && isBTree tree2